<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `&#x2F;nix&#x2F;store&#x2F;klw0pjcx3gcsqz561gi1wwv8hj1lg84w-vendored-sources&#x2F;generic-array-0.14.5&#x2F;src&#x2F;hex.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>hex.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../generic_array/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
</pre><pre class="rust"><code><span class="doccomment">//! Generic array are commonly used as a return value for hash digests, so</span>
<span class="doccomment">//! it&#39;s a good idea to allow to hexlify them easily. This module implements</span>
<span class="doccomment">//! `std::fmt::LowerHex` and `std::fmt::UpperHex` traits.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Example:</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ```rust</span>
<span class="doccomment">//! # #[macro_use]</span>
<span class="doccomment">//! # extern crate generic_array;</span>
<span class="doccomment">//! # extern crate typenum;</span>
<span class="doccomment">//! # fn main() {</span>
<span class="doccomment">//! let array = arr![u8; 10, 20, 30];</span>
<span class="doccomment">//! assert_eq!(format!(&quot;{:x}&quot;, array), &quot;0a141e&quot;);</span>
<span class="doccomment">//! # }</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//!</span>

<span class="kw">use</span> <span class="ident">core</span>::{<span class="ident">fmt</span>, <span class="ident">str</span>, <span class="ident">ops::Add</span>, <span class="ident">cmp::min</span>};

<span class="kw">use</span> <span class="ident">typenum</span>::<span class="kw-2">*</span>;

<span class="kw">use</span> <span class="kw">crate</span>::{<span class="ident">ArrayLength</span>, <span class="ident">GenericArray</span>};

<span class="kw">static</span> <span class="ident">LOWER_CHARS</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> [<span class="ident">u8</span>] <span class="op">=</span> <span class="string">b&quot;0123456789abcdef&quot;</span>;
<span class="kw">static</span> <span class="ident">UPPER_CHARS</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> [<span class="ident">u8</span>] <span class="op">=</span> <span class="string">b&quot;0123456789ABCDEF&quot;</span>;

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">ArrayLength</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="ident">fmt::LowerHex</span> <span class="kw">for</span> <span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">u8</span>, <span class="ident">T</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">T</span>: <span class="ident">Add</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>,
    <span class="op">&lt;</span><span class="ident">T</span> <span class="kw">as</span> <span class="ident">Add</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="ident">::Output</span>: <span class="ident">ArrayLength</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>,
{
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">fmt::Formatter</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">fmt::Result</span> {
        <span class="kw">let</span> <span class="ident">max_digits</span> <span class="op">=</span> <span class="ident">f</span>.<span class="ident">precision</span>().<span class="ident">unwrap_or_else</span>(<span class="op">|</span><span class="op">|</span> <span class="self">self</span>.<span class="ident">len</span>() <span class="op">*</span> <span class="number">2</span>);
        <span class="kw">let</span> <span class="ident">max_hex</span> <span class="op">=</span> (<span class="ident">max_digits</span> <span class="op">&gt;</span><span class="op">&gt;</span> <span class="number">1</span>) <span class="op">+</span> (<span class="ident">max_digits</span> <span class="op">&amp;</span> <span class="number">1</span>);

        <span class="kw">if</span> <span class="ident">T::USIZE</span> <span class="op">&lt;</span> <span class="number">1024</span> {
            <span class="comment">// For small arrays use a stack allocated</span>
            <span class="comment">// buffer of 2x number of bytes</span>
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">res</span> <span class="op">=</span> <span class="ident">GenericArray</span>::<span class="op">&lt;</span><span class="ident">u8</span>, <span class="ident">Sum</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">T</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="ident">::default</span>();

            <span class="self">self</span>.<span class="ident">iter</span>().<span class="ident">take</span>(<span class="ident">max_hex</span>).<span class="ident">enumerate</span>().<span class="ident">for_each</span>(<span class="op">|</span>(<span class="ident">i</span>, <span class="ident">c</span>)<span class="op">|</span> {
                <span class="ident">res</span>[<span class="ident">i</span> <span class="op">*</span> <span class="number">2</span>] <span class="op">=</span> <span class="ident">LOWER_CHARS</span>[(<span class="ident">c</span> <span class="op">&gt;</span><span class="op">&gt;</span> <span class="number">4</span>) <span class="kw">as</span> <span class="ident">usize</span>];
                <span class="ident">res</span>[<span class="ident">i</span> <span class="op">*</span> <span class="number">2</span> <span class="op">+</span> <span class="number">1</span>] <span class="op">=</span> <span class="ident">LOWER_CHARS</span>[(<span class="ident">c</span> <span class="op">&amp;</span> <span class="number">0xF</span>) <span class="kw">as</span> <span class="ident">usize</span>];
            });

            <span class="ident">f</span>.<span class="ident">write_str</span>(<span class="kw">unsafe</span> { <span class="ident">str::from_utf8_unchecked</span>(<span class="kw-2">&amp;</span><span class="ident">res</span>[..<span class="ident">max_digits</span>]) })<span class="question-mark">?</span>;
        } <span class="kw">else</span> {
            <span class="comment">// For large array use chunks of up to 1024 bytes (2048 hex chars)</span>
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">buf</span> <span class="op">=</span> [<span class="number">0u8</span>; <span class="number">2048</span>];
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">digits_left</span> <span class="op">=</span> <span class="ident">max_digits</span>;

            <span class="kw">for</span> <span class="ident">chunk</span> <span class="kw">in</span> <span class="self">self</span>[..<span class="ident">max_hex</span>].<span class="ident">chunks</span>(<span class="number">1024</span>) {
                <span class="ident">chunk</span>.<span class="ident">iter</span>().<span class="ident">enumerate</span>().<span class="ident">for_each</span>(<span class="op">|</span>(<span class="ident">i</span>, <span class="ident">c</span>)<span class="op">|</span> {
                    <span class="ident">buf</span>[<span class="ident">i</span> <span class="op">*</span> <span class="number">2</span>] <span class="op">=</span> <span class="ident">LOWER_CHARS</span>[(<span class="ident">c</span> <span class="op">&gt;</span><span class="op">&gt;</span> <span class="number">4</span>) <span class="kw">as</span> <span class="ident">usize</span>];
                    <span class="ident">buf</span>[<span class="ident">i</span> <span class="op">*</span> <span class="number">2</span> <span class="op">+</span> <span class="number">1</span>] <span class="op">=</span> <span class="ident">LOWER_CHARS</span>[(<span class="ident">c</span> <span class="op">&amp;</span> <span class="number">0xF</span>) <span class="kw">as</span> <span class="ident">usize</span>];
                });

                <span class="kw">let</span> <span class="ident">n</span> <span class="op">=</span> <span class="ident">min</span>(<span class="ident">chunk</span>.<span class="ident">len</span>() <span class="op">*</span> <span class="number">2</span>, <span class="ident">digits_left</span>);
                <span class="ident">f</span>.<span class="ident">write_str</span>(<span class="kw">unsafe</span> { <span class="ident">str::from_utf8_unchecked</span>(<span class="kw-2">&amp;</span><span class="ident">buf</span>[..<span class="ident">n</span>]) })<span class="question-mark">?</span>;
                <span class="ident">digits_left</span> <span class="op">-</span><span class="op">=</span> <span class="ident">n</span>;
            }
        }
        <span class="prelude-val">Ok</span>(())
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">ArrayLength</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="ident">fmt::UpperHex</span> <span class="kw">for</span> <span class="ident">GenericArray</span><span class="op">&lt;</span><span class="ident">u8</span>, <span class="ident">T</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">T</span>: <span class="ident">Add</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>,
    <span class="op">&lt;</span><span class="ident">T</span> <span class="kw">as</span> <span class="ident">Add</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="ident">::Output</span>: <span class="ident">ArrayLength</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>,
{
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">fmt::Formatter</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">fmt::Result</span> {
        <span class="kw">let</span> <span class="ident">max_digits</span> <span class="op">=</span> <span class="ident">f</span>.<span class="ident">precision</span>().<span class="ident">unwrap_or_else</span>(<span class="op">|</span><span class="op">|</span> <span class="self">self</span>.<span class="ident">len</span>() <span class="op">*</span> <span class="number">2</span>);
        <span class="kw">let</span> <span class="ident">max_hex</span> <span class="op">=</span> (<span class="ident">max_digits</span> <span class="op">&gt;</span><span class="op">&gt;</span> <span class="number">1</span>) <span class="op">+</span> (<span class="ident">max_digits</span> <span class="op">&amp;</span> <span class="number">1</span>);

        <span class="kw">if</span> <span class="ident">T::USIZE</span> <span class="op">&lt;</span> <span class="number">1024</span> {
            <span class="comment">// For small arrays use a stack allocated</span>
            <span class="comment">// buffer of 2x number of bytes</span>
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">res</span> <span class="op">=</span> <span class="ident">GenericArray</span>::<span class="op">&lt;</span><span class="ident">u8</span>, <span class="ident">Sum</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">T</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="ident">::default</span>();

            <span class="self">self</span>.<span class="ident">iter</span>().<span class="ident">take</span>(<span class="ident">max_hex</span>).<span class="ident">enumerate</span>().<span class="ident">for_each</span>(<span class="op">|</span>(<span class="ident">i</span>, <span class="ident">c</span>)<span class="op">|</span> {
                <span class="ident">res</span>[<span class="ident">i</span> <span class="op">*</span> <span class="number">2</span>] <span class="op">=</span> <span class="ident">UPPER_CHARS</span>[(<span class="ident">c</span> <span class="op">&gt;</span><span class="op">&gt;</span> <span class="number">4</span>) <span class="kw">as</span> <span class="ident">usize</span>];
                <span class="ident">res</span>[<span class="ident">i</span> <span class="op">*</span> <span class="number">2</span> <span class="op">+</span> <span class="number">1</span>] <span class="op">=</span> <span class="ident">UPPER_CHARS</span>[(<span class="ident">c</span> <span class="op">&amp;</span> <span class="number">0xF</span>) <span class="kw">as</span> <span class="ident">usize</span>];
            });

            <span class="ident">f</span>.<span class="ident">write_str</span>(<span class="kw">unsafe</span> { <span class="ident">str::from_utf8_unchecked</span>(<span class="kw-2">&amp;</span><span class="ident">res</span>[..<span class="ident">max_digits</span>]) })<span class="question-mark">?</span>;
        } <span class="kw">else</span> {
            <span class="comment">// For large array use chunks of up to 1024 bytes (2048 hex chars)</span>
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">buf</span> <span class="op">=</span> [<span class="number">0u8</span>; <span class="number">2048</span>];
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">digits_left</span> <span class="op">=</span> <span class="ident">max_digits</span>;

            <span class="kw">for</span> <span class="ident">chunk</span> <span class="kw">in</span> <span class="self">self</span>[..<span class="ident">max_hex</span>].<span class="ident">chunks</span>(<span class="number">1024</span>) {
                <span class="ident">chunk</span>.<span class="ident">iter</span>().<span class="ident">enumerate</span>().<span class="ident">for_each</span>(<span class="op">|</span>(<span class="ident">i</span>, <span class="ident">c</span>)<span class="op">|</span> {
                    <span class="ident">buf</span>[<span class="ident">i</span> <span class="op">*</span> <span class="number">2</span>] <span class="op">=</span> <span class="ident">UPPER_CHARS</span>[(<span class="ident">c</span> <span class="op">&gt;</span><span class="op">&gt;</span> <span class="number">4</span>) <span class="kw">as</span> <span class="ident">usize</span>];
                    <span class="ident">buf</span>[<span class="ident">i</span> <span class="op">*</span> <span class="number">2</span> <span class="op">+</span> <span class="number">1</span>] <span class="op">=</span> <span class="ident">UPPER_CHARS</span>[(<span class="ident">c</span> <span class="op">&amp;</span> <span class="number">0xF</span>) <span class="kw">as</span> <span class="ident">usize</span>];
                });

                <span class="kw">let</span> <span class="ident">n</span> <span class="op">=</span> <span class="ident">min</span>(<span class="ident">chunk</span>.<span class="ident">len</span>() <span class="op">*</span> <span class="number">2</span>, <span class="ident">digits_left</span>);
                <span class="ident">f</span>.<span class="ident">write_str</span>(<span class="kw">unsafe</span> { <span class="ident">str::from_utf8_unchecked</span>(<span class="kw-2">&amp;</span><span class="ident">buf</span>[..<span class="ident">n</span>]) })<span class="question-mark">?</span>;
                <span class="ident">digits_left</span> <span class="op">-</span><span class="op">=</span> <span class="ident">n</span>;
            }
        }
        <span class="prelude-val">Ok</span>(())
    }
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="generic_array" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>